/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Miroslav Kure <kurem@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef DATA_H
#define DATA_H

/* Data variables */
typedef struct _State State;
struct _State {
    int id;
    char *name;
    char *atribute;
    GnomeCanvasGroup *group;
};

typedef struct _Transition Transition;
struct _Transition {
    State *from;
    State *to;
    GSList *entry_symbols;
    GSList *from_stack;
    GSList *to_stack;
    GnomeCanvasGroup *group;
};

typedef struct _Symbol Symbol;
struct _Symbol {
    int id;
    char *name;
    char *atribute;
};

typedef struct _Rule Rule;
struct _Rule {
    GSList *right;
    GSList *left;
};

typedef enum {
    NOTHING, FINITE, STACK, REGULAR, CONTEXTFREE, GRAMMAR
} KIND;

typedef struct {
    GSList *states;
    GSList *entry_symbols;
    GSList *stack_symbols;
    GSList *transitions;
} automata;

typedef struct {
    GSList *nonterminal_symbols;
    GSList *terminal_symbols;
    GSList *rules;
} grammar;

typedef struct _Coordinate Coordinate;
struct _Coordinate {
    int id;
    double x;
    double y;
};

typedef struct _Pair Pair;
struct _Pair {
    State *state;
    GSList *stack;
};

struct finite_automata_struc *fa;
struct stack_automata_struc *sa;
struct regular_grammar_struc *rg;
struct contextfree_grammar_struc *cg;
struct grammar_struc *g;

#endif

