#ifndef GUI_H
#define GUI_H

/* functions */
extern void nothing_cb(GtkWidget *widget, gpointer data);

extern void add_state_cb(GtkWidget *widget, gpointer data);
extern void add_entry_symbol_cb(GtkWidget *widget, gpointer data);
extern void add_stack_symbol_cb(GtkWidget *widget, gpointer data);
extern void add_nonterminal_symbol_cb(GtkWidget *widget, gpointer data);
extern void add_terminal_symbol_cb(GtkWidget *widget, gpointer data);
extern void add_transition_cb(GtkWidget *widget, gpointer data);
extern void add_rule_cb(GtkWidget *widget, gpointer data);

extern void remove_state_cb(GtkWidget *widget, gpointer data);
extern void remove_entry_symbol_cb(GtkWidget *widget, gpointer data);
extern void remove_stack_symbol_cb(GtkWidget *widget, gpointer data);
extern void remove_transition_cb(GtkWidget *widget, gpointer data);
extern void remove_terminal_symbol_cb(GtkWidget *widget, gpointer data);
extern void remove_nonterminal_symbol_cb(GtkWidget *widget, gpointer data);
extern void remove_rule_cb(GtkWidget *widget, gpointer data);

extern void edit_state_cb(GtkWidget *widget, gpointer data);
extern void edit_entry_symbol_cb(GtkWidget *widget, gpointer data);
extern void edit_stack_symbol_cb(GtkWidget *widget, gpointer data);
extern void edit_terminal_symbol_cb(GtkWidget *widget, gpointer data);
extern void edit_nonterminal_symbol_cb(GtkWidget *widget, gpointer data);

extern void set_start_state_cb(GtkWidget *widget, gpointer data);
extern void set_end_state_cb(GtkWidget *widget, gpointer data);
extern void reset_end_state_cb(GtkWidget *widget, gpointer data);
extern void set_start_stack_symbol_cb(GtkWidget *widget, gpointer data);
extern void set_start_symbol_cb(GtkWidget *widget, gpointer data);

extern void direct_add_transition_cb(GtkWidget *widget, gpointer data);
extern void direct_set_start_state_cb(GtkWidget *widget, gpointer data);
extern void direct_set_end_state_cb(GtkWidget *widget, gpointer data);
extern void direct_reset_end_state_cb(GtkWidget *widget, gpointer data);
extern void direct_edit_state_cb(GtkWidget *widget, gpointer data);
extern void direct_delete_state_cb(GtkWidget *widget, gpointer data);
extern void direct_add_symbol_cb(GtkWidget *widget, gpointer data);
extern void direct_delete_symbol_cb(GtkWidget *widget, gpointer data);
extern void direct_delete_transition_cb(GtkWidget *widget, gpointer data);
extern void direct_delete_stack_trans_cb(GtkWidget *widget, gpointer data);
extern void direct_delete_rule_cb(GtkWidget *widget, gpointer data);

extern void get_inaccessible_states_cb(GtkWidget *widget, gpointer data);
extern void get_redundant_symbols_cb(GtkWidget *widget, gpointer data);
extern void get_recursive_symbols_cb(GtkWidget *widget, gpointer data);
extern void get_inaccessible_symbols_cb(GtkWidget *widget, gpointer data);
extern void get_simple_rules_cb(GtkWidget *widget, gpointer data);
extern void get_e_rules_cb(GtkWidget *widget, gpointer data);

extern void check_sentence_cb(GtkWidget *widget, gpointer data);
extern void set_configuration_cb(GtkWidget *widget, gpointer data);
extern void is_deterministic_cb(GtkWidget *widget, gpointer data);
extern void is_top_stack_working_cb(GtkWidget *widget, gpointer data);
extern void is_empty_stack_recognising_cb(GtkWidget *widget, gpointer data);

extern void get_classification_cb(GtkWidget *widget, gpointer data);
extern void is_e_rules_free_cb(GtkWidget *widget, gpointer data);
extern void is_self_cb(GtkWidget *widget, gpointer data);
extern void is_in_chomsky_nf_cb(GtkWidget *widget, gpointer data);
extern void is_in_greibach_nf_cb(GtkWidget *widget, gpointer data);
extern void is_recursive_cb(GtkWidget *widget, gpointer data);
extern void do_finite_transition_cb(GtkWidget *widget, gpointer data);
extern void do_stack_transition_cb(GtkWidget *widget, gpointer data);

extern void to_deterministic_cb(GtkWidget *widget, gpointer data);
extern void to_reduced_cb(GtkWidget *widget, gpointer data);
extern void to_top_stack_working_cb(GtkWidget *widget, gpointer data);
extern void to_empty_stack_recognising_cb(GtkWidget *widget, gpointer data);
extern void to_end_states_recognising_cb(GtkWidget *widget, gpointer data);
extern void to_extended_cb(GtkWidget *widget, gpointer data);
extern void to_self_cb(GtkWidget *widget, gpointer data);
extern void to_chomsky_nf_cb(GtkWidget *widget, gpointer data);
extern void to_greibach_nf_cb(GtkWidget *widget, gpointer data);
extern void remove_redundant_symbols_cb(GtkWidget *widget, gpointer data);
extern void remove_e_rules_cb(GtkWidget *widget, gpointer data);
extern void remove_simple_rules_cb(GtkWidget *widget, gpointer data);
extern void eliminate_left_recursion_cb(GtkWidget *widget, gpointer data);

extern void convert_cb(GtkWidget *widget, gpointer data);
extern void comment_cb(GtkWidget *widget, gpointer data);
extern void show_current_menu();

/* gui variables */
extern GtkWidget *app;

#endif
