/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Miroslav Kure <kurem@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef POPUP_H
#define POPUP_H

GnomeUIInfo popup[] = {
    GNOMEUIINFO_MENU_NEW_ITEM(N_("_Add new state..."),
			      N_("Add new state to automata"),
			      add_state_cb, NULL),
    GNOMEUIINFO_MENU_NEW_ITEM(N_("_Add new entry symbol..."),
			      N_("Add new entry symbol to automata"),
			      add_entry_symbol_cb, NULL),
    GNOMEUIINFO_MENU_NEW_ITEM(N_("_Add new transition..."),
			      N_("Add new transition to automata"),
			      prepare_transition, NULL),
    GNOMEUIINFO_SEPARATOR,
    GNOMEUIINFO_ITEM_NONE(N_("_Delete entry symbol"),
			  N_("Delete entry symbol"),
			  remove_entry_symbol_cb),
    GNOMEUIINFO_END
};

GnomeUIInfo state_popup[] = {
    GNOMEUIINFO_ITEM_NONE(N_("_Set as starting state"),
			  N_("Mark this state as starting"),
			  direct_set_start_state_cb),
    GNOMEUIINFO_ITEM_NONE(N_("Set _as ending state"),
			  N_("Mark this state as ending"),
			  direct_set_end_state_cb),
    GNOMEUIINFO_ITEM_NONE(N_("_Reset end flag"),
			  N_("Remove 'ending state' flag"),
			  direct_reset_end_state_cb),
    GNOMEUIINFO_ITEM_NONE(N_("_Edit this state"),
			  N_("Edit this item"),
			  direct_edit_state_cb),
    GNOMEUIINFO_SEPARATOR,
    GNOMEUIINFO_ITEM_NONE(N_("_Delete this state"),
			  N_("Delete this item"),
			  direct_delete_state_cb),
    GNOMEUIINFO_END
};

GnomeUIInfo transition_popup[] = {
    GNOMEUIINFO_MENU_NEW_ITEM(N_("_Add symbol to this transition"),
			      N_("Add symbol to this transition"),
			      direct_add_symbol_cb, NULL),
    GNOMEUIINFO_ITEM_NONE(N_("_Remove symbol from this transition"),
			  N_("Remove symbol from this transition"),
			  direct_delete_symbol_cb),
    GNOMEUIINFO_SEPARATOR,
    GNOMEUIINFO_ITEM_NONE(N_("_Delete this whole transition"),
			  N_("Delete this whole transition"),
			  direct_delete_transition_cb),
    GNOMEUIINFO_END
};

#endif
