/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "interface.h"

Formal_mico_var formal_mico; // Formal_mico object

// this is the main function from client
extern "C" int
main_client(int argc, char *argv[]);

int
main(int argc, char *argv[])
{
  /*
   * Initialize the ORB
   */

  CORBA::ORB_var orb = CORBA::ORB_init (argc, argv, "mico-local-orb");

  /*
   * Bind to the Formal_mico server
   */

  CORBA::Object_var obj = orb->bind ("IDL:Formal_mico:1.0");

  if (CORBA::is_nil (obj)) {
    printf ("%s-client: bind to interface Formal_mico failed\n", PACKAGE);
    printf ("Is %s-server running? Check its address.\n\n", PACKAGE);
    exit (1);
  }

  if ((argc > 1) && (*argv[1] == 't')) exit(0);

  formal_mico = Formal_mico::_narrow (obj);

  return main_client(argc, argv);
}
