#!/bin/sh

dist_bin=`dirname $0`
SERVER=$dist_bin/gaae-server
CLIENT=$dist_bin/gaae-client

INET=`uname -n`
ADDR=inet:$INET:12456

MICORC=/dev/null
export MICORC

gaae_usage()
{
	cat << EOF
	
Usage: gaae [server | client [server_host]]

  Examples:

  Run both server and client
  
    gaae

  Run the server in the background
  
    gaae server
  
  Run the client (Server is supposed to be running at local)
  
    gaae client

  Run the client (Server is supposed to be running at machine "server_host")
  
    gaae client server_host

EOF
	return 0
}

if [ ! -x $SERVER -o ! -x $CLIENT ]; then
	echo "$SERVER or $CLIENT file is missing or not executable."
	exit 1
fi

if [ -z $1 ]; then
    $CLIENT -ORBBindAddr $ADDR t >/dev/null 2>&1
    server_test=$?
    if [ $server_test = 1 ]; then
    	$SERVER -ORBIIOPAddr $ADDR &
    	sleep 1
    	SERVER_PID=$!
    	trap "kill $SERVER_PID" 0
    else echo "Server already running at address $INET"
    fi
    $CLIENT -ORBBindAddr $ADDR
else

case "$1" in
    server)
    	$CLIENT -ORBBindAddr $ADDR t >/dev/null 2>&1
        server_test=$?
	if [ $server_test = 1 ]; then
	    $SERVER -ORBIIOPAddr $ADDR &
	    sleep 1
	    echo "Server address (for client): $INET"
	    echo "Server pid: $!"
	else echo "Server already running at address $INET"
	fi
	;;
    client)
        if [ -z $2 ]; then
		$CLIENT -ORBBindAddr $ADDR
	else
		$CLIENT -ORBBindAddr inet:$2:12456
	fi			
	;;
    ?*)
    	gaae_usage
	exit 1
	;;
esac

fi

exit 0
