/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* server error states and functions */

#ifndef __SERVER_ERROR_H__
#define __SERVER_ERROR_H__

enum t_server_error {
  E_SERVER_NOERR, /* no error */
  E_SERVER_A_STATE_MAX, /* state max count reached */
  E_SERVER_A_STATE_BAD, /* state isn't known */
  E_SERVER_A_ENTRY_SYMBOL_MAX,
  E_SERVER_A_ENTRY_SYMBOL_BAD,
  E_SERVER_A_TRANSITION_BAD,
  E_SERVER_AF_SENTENCE_EMPTY, /* sentence is empty */
  E_SERVER_AF_STATE_CANT_REACH, /* state can't be reached */
  E_SERVER_AF_NOT_DETERMINISTIC, /* finite automata is not deterministic */
  E_SERVER_AS_STACK_SYMBOL_MAX,
  E_SERVER_AS_STACK_SYMBOL_BAD,
  E_SERVER_AS_STATE_STACK_CANT_REACH, /* state & stack pair can't be reached */
  E_SERVER_AS_STACK_CANT_POP, /* stack can't be popped */
  E_SERVER_A_STATE_NAME_EXISTS, /* there already is state with such name */
  E_SERVER_A_ENTRY_SYMBOL_NAME_EXISTS,
  E_SERVER_AS_STACK_SYMBOL_NAME_EXISTS,
  E_SERVER_G_NONTERMINAL_SYMBOL_MAX,
  E_SERVER_G_NONTERMINAL_SYMBOL_BAD,
  E_SERVER_G_TERMINAL_SYMBOL_MAX,
  E_SERVER_G_TERMINAL_SYMBOL_BAD,
  E_SERVER_G_RULE_BAD,
  E_SERVER_GR_RULE_BAD, /* rule isn't for regular grammar */
  E_SERVER_GC_RULE_BAD, /* rule isn't for contextfree grammar */
  E_SERVER_GC_NOT_ERULES_FREE, /* contextfree grammar is not e-rules-free */
  E_SERVER_GC_NOT_SELF, /* contextfree grammar is not self */
  E_SERVER_GC_HAS_SIMPLE_RULES, /* contextfree grammar has simple rules */
  E_SERVER_GC_IS_LEFT_RECURSIVE, /* contextfree grammar is left recursive */
  E_SERVER_G_NONTERMINAL_SYMBOL_NAME_EXISTS,
  E_SERVER_G_TERMINAL_SYMBOL_NAME_EXISTS
};

#endif
