/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// types of automata elements

#ifndef __AUTOMATA_ELEMENTS_H__
#define __AUTOMATA_ELEMENTS_H__

// State - must be convertible to unsigned int
typedef unsigned int State;
#define State_NULL 0
#define State_MIN 1
#define State_MAX 10000

// Entry symbol - must be convertible to unsigned int
typedef unsigned int EntrySymbol;
#define EntrySymbol_NULL 0
#define EntrySymbol_MIN 10001
#define EntrySymbol_MAX 20000

// Transition
struct Transition {
  State from_state;
  EntrySymbol entry_symbol;
  State to_state;
  // comparison function
  bool 
  operator<(const Transition &tran) const
  {
    if (from_state < tran.from_state) return true;
    if (from_state > tran.from_state) return false;
    if (entry_symbol < tran.entry_symbol) return true;
    if (entry_symbol > tran.entry_symbol) return false;
    return to_state < tran.to_state;
  }
};

#endif
