/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// classes of automata element looks

#ifndef __AUTOMATA_ELEMENTS_L_H__
#define __AUTOMATA_ELEMENTS_L_H__

#include "automata_elements.h"
#include <string>

// State look
class State_l {
 protected:
  string name;
 public:
  State_l();
  State_l(string n);
  string getName();
  // returns: state name
  enum t_flags { F_START = 1, F_END = 2 }; 
  string getLook(State state, t_flags flags);
  // returns: State look: (state _id_ _name_ [s][e])
  // [x] = x is optional
 protected:
  string State_to_string(State state);
};

// EntrySymbol look
class EntrySymbol_l {
 protected:
  string name;
 public:
  EntrySymbol_l();
  EntrySymbol_l(string n);
  string getName();
  // eturns: entry symbol name
  string getLook(EntrySymbol symbol);
  // returns: EntrySymbol look: (entry_symbol _id_ _name_)
 protected:
  string EntrySymbol_to_string(EntrySymbol symbol);
};

#endif
