/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __CONVERSIONS_L_H__
#define __CONVERSIONS_L_H__

#include "finite_automata_l.h"
#include "regular_grammar_l.h"
#include "stack_automata_l.h"
#include "contextfree_grammar_l.h"

FiniteAutomata_l
RegularGrammar_l_to_FiniteAutomata_l(RegularGrammar_l *grammar);
// converts regular grammar look grammar to equivalent finite automata look
// returns: new finite automata look

RegularGrammar_l
FiniteAutomata_l_to_RegularGrammar_l(FiniteAutomata_l *automata);
// converts finite automata look automata to equivalent regular grammar look
// returns: new regular grammar look

StackAutomata_l
ContextfreeGrammar_l_to_StackAutomata_l(ContextfreeGrammar_l *grammar,
					bool top_down);
// converts contextfree grammar look grammar to equivalent stack automata look
// top-down or bottom-up method specified in top_down
// returns: new stack automata look

ContextfreeGrammar_l
StackAutomata_l_to_ContextfreeGrammar_l(StackAutomata_l *automata);
// converts stack automata look automata to equivalent contextfree grammar look
// returns: new contextfree grammar look

#endif
