/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// error states and functions

#ifndef __ERROR_H__
#define __ERROR_H__

enum t_error {
  E_NOERR, // no error
  E_A_STATE_MAX, // state max count reached
  E_A_STATE_BAD, // state isn't known
  E_A_ENTRY_SYMBOL_MAX,
  E_A_ENTRY_SYMBOL_BAD,
  E_A_TRANSITION_BAD,
  E_AF_SENTENCE_EMPTY, // sentence is empty
  E_AF_STATE_CANT_REACH, // state can't be reached
  E_AF_NOT_DETERMINISTIC, // finite automata is not deterministic
  E_AS_STACK_SYMBOL_MAX,
  E_AS_STACK_SYMBOL_BAD,
  E_AS_STATE_STACK_CANT_REACH, // state & stack pair can't be reached
  E_AS_STACK_CANT_POP, // stack can't be popped
  E_A_STATE_NAME_EXISTS, // there already is state with such name
  E_A_ENTRY_SYMBOL_NAME_EXISTS,
  E_AS_STACK_SYMBOL_NAME_EXISTS,
  E_G_NONTERMINAL_SYMBOL_MAX,
  E_G_NONTERMINAL_SYMBOL_BAD,
  E_G_TERMINAL_SYMBOL_MAX,
  E_G_TERMINAL_SYMBOL_BAD,
  E_G_RULE_BAD,
  E_GR_RULE_BAD, // rule isn't for regular grammar
  E_GC_RULE_BAD, // rule isn't for contextfree grammar
  E_GC_NOT_ERULES_FREE, // contextfree grammar is not e-rules-free
  E_GC_NOT_SELF, // contextfree grammar is not self
  E_GC_HAS_SIMPLE_RULES, // contextfree grammar has simple rules
  E_GC_IS_LEFT_RECURSIVE, // contextfree grammar is left recursive
  E_G_NONTERMINAL_SYMBOL_NAME_EXISTS,
  E_G_TERMINAL_SYMBOL_NAME_EXISTS
};

int getError();
// returns: last error wherever in the implementation classes

void setError(int err);
// set error to err

#endif
