/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// types of grammar elements

#ifndef __GRAMMAR_ELEMENTS_H__
#define __GRAMMAR_ELEMENTS_H__

#include <vector>

// Symbol - must be convertible to unsigned int
typedef unsigned int Symbol;
#define Symbol_NULL 0
#define Symbol_MIN 1
#define Symbol_MAX 20000

// NonterminalSymbol - must be convertible to unsigned int
typedef unsigned int NonterminalSymbol;
#define NonterminalSymbol_NULL 0
#define NonterminalSymbol_MIN 1
#define NonterminalSymbol_MAX 10000

// TerminalSymbol - must be convertible to unsigned int
typedef unsigned int TerminalSymbol;
#define TerminalSymbol_NULL 0
#define TerminalSymbol_MIN 10001
#define TerminalSymbol_MAX 20000

// Rule
struct Rule {
  vector<Symbol> left;
  vector<Symbol> right;
  bool
  operator<(const Rule &rule) const
  {
    if (left < rule.left) return true;
    if (left > rule.left) return false;
    return right < rule.right;
  }
};

#endif
