/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// classes of grammar element looks

#ifndef __GRAMMAR_ELEMENTS_L_H__
#define __GRAMMAR_ELEMENTS_L_H__

#include "grammar_elements.h"
#include <string>

// Nonterminal symbol look
class NonterminalSymbol_l {
 protected:
  string name;
 public:
  NonterminalSymbol_l();
  NonterminalSymbol_l(string n);
  string getName();
  // returns: symbol name
  enum t_flags { F_START = 1 }; 
  string getLook(NonterminalSymbol symbol, t_flags flags);
  // returns: Nonterminal symbol look: (nonterminal_symbol _id_ _name_ [s])
  // [x] = x is optional
 protected:
  string NonterminalSymbol_to_string(NonterminalSymbol symbol);
};

// Terminal symbol look
class TerminalSymbol_l {
 protected:
  string name;
 public:
  TerminalSymbol_l();
  TerminalSymbol_l(string n);
  string getName();
  // returns: symbol name
  string getLook(TerminalSymbol symbol);
  // returns: Terminal symbol look: (terminal_symbol _id_ _name_)
 protected:
  string TerminalSymbol_to_string(TerminalSymbol symbol);
};

#endif
