/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// class of the regular grammar

#ifndef __REGULAR_GRAMMAR_H__
#define __REGULAR_GRAMMAR_H__

#include "grammar.h"

class RegularGrammar : public Grammar {
 public:
  RegularGrammar();
  ~RegularGrammar();
  bool addRule(Rule& rule, vector<Symbol> left, vector<Symbol> right);
  // adds new rule consisting of left and right part
  // returns: if successful, in rule new rule
  // errors: E_G_NONTERMINAL_SYMBOL_BAD, E_G_TERMINAL_SYMBOL_BAD, E_GR_RULE_BAD
  bool addRule(vector<Symbol> left, vector<Symbol> right);
  // adds new rule consisting of left and right part
  // returns: if successful
  // errors: E_G_NONTERMINAL_SYMBOL_BAD, E_G_TERMINAL_SYMBOL_BAD, E_GR_RULE_BAD
};

#endif
