/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// types of the stack automata elements

#ifndef __STACK_AUTOMATA_ELEMENTS_H__
#define __STACK_AUTOMATA_ELEMENTS_H__

#include "automata_elements.h"
#include <vector>

// Stack symbol - must be convertible to unsigned int
typedef unsigned int StackSymbol;
#define StackSymbol_NULL 0
#define StackSymbol_MIN 20001
#define StackSymbol_MAX 30000

// Stack transition
struct StackTransition : public Transition {
  vector<StackSymbol> from_stack;
  vector<StackSymbol> to_stack;
  bool
  operator<(const StackTransition &tran) const
  {
    if (from_state < tran.from_state) return true;
    if (from_state > tran.from_state) return false;
    if (entry_symbol < tran.entry_symbol) return true;
    if (entry_symbol > tran.entry_symbol) return false;
    if (to_state < tran.to_state) return true;
    if (to_state > tran.to_state) return false;
    if (from_stack < tran.from_stack) return true;
    if (from_stack > tran.from_stack) return false;
    return to_stack < tran.to_stack;
  }
};

#endif
