/* GAAE - GAAE Ain't an Automata Editor
 * Copyright (C) 2001 Jan Outrata <outrataj@upcase.inf.upol.cz>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "stack_automata_elements_l.h"

const char string_space = ' ';
const char string_lbracket = '(';
const char string_rbracket = ')';

StackSymbol_l::StackSymbol_l()
{
  name = "";
}

StackSymbol_l::StackSymbol_l(string n)
{
  name = n;
}

// can't be inline
string
StackSymbol_l::getName()
{
  return name;
}

string
StackSymbol_l::getLook(StackSymbol symbol, t_flags flags)
{
  string result;
  if (symbol == 0) return result;
  result += string_lbracket;
  result += "stack_symbol";
  result += string_space + StackSymbol_to_string(symbol) + string_space;
  result += name;
  string flag_string;
  if (flags & F_START) flag_string += 's';
  if (!flag_string.empty()) result += string_space + flag_string;
  result += string_rbracket;
  return result;
}

string
StackSymbol_l::StackSymbol_to_string(StackSymbol symbol)
{
  string result;
  for (; symbol > 0; symbol /= 10) result += symbol % 10 + '0';
  if (result.empty()) result = '0';
  reverse(result.begin(), result.end());
  return result;
}
